blob: 77f22489f99bbd356ea0498d9729a12c40291435 [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with this program; if not, write to the Free Software
Patrick Georgib890a122015-03-26 15:17:45 +010020# Foundation, Inc.
Stefan Reinauer074d9132009-09-26 16:43:17 +000021#
22
Stefan Reinauerd7649122015-06-09 11:44:25 -070023cd $(dirname $0)
Patrick Georgi8135dba2015-03-17 21:05:20 +010024
Stefan Reinauerbed95b22015-06-09 13:41:40 -070025CROSSGCC_DATE="June 9th, 2015"
26CROSSGCC_VERSION="1.30"
Stefan Reinauer074d9132009-09-26 16:43:17 +000027
28# default settings
Stefan Reinauerd7649122015-06-09 11:44:25 -070029TARGETDIR=$(pwd)/xgcc
Stefan Reinauer074d9132009-09-26 16:43:17 +000030TARGETARCH=i386-elf
31DESTDIR=
32
Stefan Reinauer699ac272015-06-05 12:43:28 -070033# GCC toolchain version numbers
Patrick Georgi53c388f2015-03-07 09:55:18 +010034GMP_VERSION=6.0.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070035MPFR_VERSION=3.1.2
Paul Menzele6619422015-02-23 10:33:59 +010036MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000037LIBELF_VERSION=0.8.13
Patrick Georgi53c388f2015-03-07 09:55:18 +010038GCC_VERSION=4.9.2
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070039GCC_AUTOCONF_VERSION=2.69
Patrick Georgi53c388f2015-03-07 09:55:18 +010040BINUTILS_VERSION=2.25
Stefan Reinauerbed95b22015-06-09 13:41:40 -070041GDB_VERSION=7.9.1
Patrick Georgi53c388f2015-03-07 09:55:18 +010042IASL_VERSION=20150204
43PYTHON_VERSION=3.4.3
Idwer Vollering296a0152012-10-26 01:48:04 +020044EXPAT_VERSION=2.1.0
Stefan Reinauer14ce2132015-06-05 13:01:13 -070045# CLANG version number
46CLANG_VERSION=3.6.1
Stefan Reinauer074d9132009-09-26 16:43:17 +000047
Stefan Reinauer699ac272015-06-05 12:43:28 -070048# GCC toolchain archive locations
Patrick Georgi53c388f2015-03-07 09:55:18 +010049GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}a.tar.bz2"
Patrick Georgi6e61ad32012-05-12 23:19:30 +020050MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.bz2"
Idwer Vollering7962fc72012-10-25 02:14:09 +020051MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000052LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020053GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070054BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010055GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
56IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix-${IASL_VERSION}.tar.gz"
57PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010058EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.gz"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070059# CLANG toolchain archive locations
60LLVM_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/llvm-${CLANG_VERSION}.src.tar.xz"
61CFE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/cfe-${CLANG_VERSION}.src.tar.xz"
62CRT_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/compiler-rt-${CLANG_VERSION}.src.tar.xz"
63CTE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/clang-tools-extra-${CLANG_VERSION}.src.tar.xz"
Stefan Reinauer074d9132009-09-26 16:43:17 +000064
Stefan Reinauer699ac272015-06-05 12:43:28 -070065# GCC toolchain directories
Stefan Reinauer074d9132009-09-26 16:43:17 +000066GMP_DIR="gmp-${GMP_VERSION}"
67MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000068MPC_DIR="mpc-${MPC_VERSION}"
69LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000070GCC_DIR="gcc-${GCC_VERSION}"
71BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
72GDB_DIR="gdb-${GDB_VERSION}"
Marc Jones2aac3f62011-08-08 16:07:50 -060073IASL_DIR="acpica-unix-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010074PYTHON_DIR="Python-${PYTHON_VERSION}"
75EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070076# CLANG toolchain directories
77LLVM_DIR="llvm-${CLANG_VERSION}.src"
78CFE_DIR="cfe-${CLANG_VERSION}.src"
79CRT_DIR="compiler-rt-${CLANG_VERSION}.src"
80CTE_DIR="clang-tools-extra-${CLANG_VERSION}.src"
Stefan Reinauer074d9132009-09-26 16:43:17 +000081
Patrick Georgi6321f522015-02-27 23:36:26 +010082unset MAKELEVEL MAKEFLAGS
83
Stefan Reinauer074d9132009-09-26 16:43:17 +000084SAVETEMPS=0
Stefan Reinauer14ce2132015-06-05 13:01:13 -070085BUILDCLANG=0
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010086SKIPGDB=1
87SKIPPYTHON=1
Stefan Reinauer074d9132009-09-26 16:43:17 +000088
Patrick Georgi1861ff72011-10-31 12:15:55 +010089red='\033[0;31m'
90RED='\033[1;31m'
91green='\033[0;32m'
92GREEN='\033[1;32m'
93blue='\033[0;34m'
94BLUE='\033[1;34m'
95cyan='\033[0;36m'
96CYAN='\033[1;36m'
97NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +000098
Stefan Reinauerd7649122015-06-09 11:44:25 -070099UNAME=$(uname)
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700100
Patrick Georgi198d23c2012-12-08 08:02:44 +0100101normalize_dirs()
102{
103 mkdir -p $DESTDIR$TARGETDIR/lib
104 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
105 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
106 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
107
108 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
109 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
110}
111
Patrick Georgib7062882015-02-24 10:52:14 +0100112searchtool()
Stefan Reinauer074d9132009-09-26 16:43:17 +0000113{
114 # $1 short name
Patrick Georgib7062882015-02-24 10:52:14 +0100115 # $2 search string
116 # $3 soft fail if set
117 # result: file name of that tool on stdout
118 # or no output if nothing suitable was found
119 search=GNU
120 if [ -n "$2" ]; then
121 search="$2"
122 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000123 for i in "$1" "g$1" "gnu$1"; do
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700124 if [ -x "$(which $i 2>/dev/null)" ]; then
125 if [ "$(cat /dev/null | $i --version 2>&1 | grep -c "$search")" \
126 -gt 0 ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000127 echo $i
128 return
129 fi
130 fi
131 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800132 # A workaround for OSX 10.9 and some BSDs, whose nongnu
133 # patch and tar also work.
Patrick Georgi7cb26b42015-04-28 21:29:22 +0200134 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" -o $UNAME = "OpenBSD" ]; then
Patrick Georgib7062882015-02-24 10:52:14 +0100135 if [ "$1" = "patch" -o "$1" = "tar" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700136 if [ -x "$(which $1 2>/dev/null)" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800137 echo $1
138 return
139 fi
140 fi
141 fi
Stefan Reinauerd7649122015-06-09 11:44:25 -0700142 if [ "$(echo $1 | cut -b -3)" = "sha" ]; then
zbao939dc842015-04-30 04:44:07 +0800143 if [ $UNAME = "FreeBSD" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700144 if [ -x "$(which sha1 2>/dev/null)" ]; then
zbao939dc842015-04-30 04:44:07 +0800145 echo sha1
146 return
147 fi
148 fi
149 if [ $UNAME = "NetBSD" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700150 if [ -x "$(which cksum 2>/dev/null)" ]; then
Stefan Reinauerd7649122015-06-09 11:44:25 -0700151 echo cksum -a $(echo $1 | sed -e 's,sum,,')
zbao939dc842015-04-30 04:44:07 +0800152 return
153 fi
154 fi
155 if [ $UNAME = "Darwin" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700156 if [ -x "$(which openssl 2>/dev/null)" ]; then
Stefan Reinauerd7649122015-06-09 11:44:25 -0700157 echo openssl $(echo $1 | sed -e 's,sum,,')
zbao939dc842015-04-30 04:44:07 +0800158 return
159 fi
160 fi
161 fi
Patrick Georgiae5ab602015-04-29 23:30:15 +0200162 printf "${RED}ERROR:${red} Missing tool: Please install $1 (eg using your OS packaging system)${NC}\n" >&2
Patrick Georgib7062882015-02-24 10:52:14 +0100163 [ -z "$3" ] && exit 1
164 false
Stefan Reinauer074d9132009-09-26 16:43:17 +0000165}
166
Stefan Reinauerd7649122015-06-09 11:44:25 -0700167TAR=$(searchtool tar) || exit $?
168PATCH=$(searchtool patch) || exit $?
169MAKE=$(searchtool make) || exit $?
170CMAKE=$(searchtool cmake "cmake") || exit $?
171SHA1SUM=$(searchtool sha1sum)
172SHA512SUM=$(searchtool sha512sum)
Stefan Reinauer699ac272015-06-05 12:43:28 -0700173CHECKSUM=$SHA1SUM
Stefan Reinauer074d9132009-09-26 16:43:17 +0000174
Patrick Georgib7062882015-02-24 10:52:14 +0100175searchtool m4 > /dev/null
176searchtool bison > /dev/null
177searchtool flex flex > /dev/null
178searchtool g++ "Free Software Foundation" nofail > /dev/null || \
Patrick Georgi915c4fc2015-03-09 13:58:23 +0100179searchtool clang "clang version" > /dev/null
180searchtool wget > /dev/null
181searchtool bzip2 "bzip2," > /dev/null
Patrick Georgi5fb2b5c2012-05-12 23:25:23 +0200182
Stefan Reinauer88935482015-06-05 09:51:10 -0700183download() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700184 package=$1
185 archive="$(eval echo \$$package"_ARCHIVE")"
Stefan Reinauer699ac272015-06-05 12:43:28 -0700186
Stefan Reinauerd7649122015-06-09 11:44:25 -0700187 FILE=$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700188 printf " * $FILE "
189
190 test -f tarballs/$FILE && \
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700191 ( test -z "$CHECKSUM" || \
192 test "$(cat sum/$FILE.cksum 2>/dev/null | \
193 sed -e 's,.*\([0-9a-f]\{40\}\).*,\1,')" = \
194 "$($CHECKSUM tarballs/$FILE 2>/dev/null | \
195 sed -e 's,.*\([0-9a-f]\{40\}\).*,\1,')" ) && \
Stefan Reinauer88935482015-06-05 09:51:10 -0700196 printf "(cached)" || (
197 printf "(downloading)"
198 rm -f tarballs/$FILE
199 cd tarballs
Stefan Reinauer699ac272015-06-05 12:43:28 -0700200 wget --no-check-certificate -q $archive
Stefan Reinauer88935482015-06-05 09:51:10 -0700201 cd ..
202 test ! -f sum/$FILE.cksum && test -f tarballs/$FILE && \
203 (test -z "$CHECKSUM" || $CHECKSUM tarballs/$FILE > sum/$FILE.cksum ) && \
204 printf "(checksum created. ${RED}Note. Please upload sum/$FILE.cksum if the corresponding archive is upgraded.${NC})"
205 )
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700206 if [ ! -f tarballs/$FILE ]; then
Stefan Reinauer88935482015-06-05 09:51:10 -0700207 printf "\n${RED}Failed to download $FILE.${NC}\n"
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700208 exit 1
209 fi
Stefan Reinauer88935482015-06-05 09:51:10 -0700210 printf "\n"
211}
212
213unpack_and_patch() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700214 package=$1
215 archive="$(eval echo \$$package"_ARCHIVE")"
216 dir="$(eval echo \$$package"_DIR")"
Stefan Reinauer88935482015-06-05 09:51:10 -0700217 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauerd7649122015-06-09 11:44:25 -0700218 printf " * $(basename $archive)\n"
Stefan Reinauer88935482015-06-05 09:51:10 -0700219 FLAGS=zxf
Stefan Reinauerd7649122015-06-09 11:44:25 -0700220 suffix=$(echo $archive | sed 's,.*\.,,')
Stefan Reinauer88935482015-06-05 09:51:10 -0700221 test "$suffix" = "gz" && FLAGS=zxf
222 test "$suffix" = "bz2" && FLAGS=jxf
223 test "$suffix" = "xz" && FLAGS="--xz -xf"
224 test "$suffix" = "lzma" && FLAGS="--lzma -xf"
Stefan Reinauerd7649122015-06-09 11:44:25 -0700225 $TAR $FLAGS tarballs/$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700226 for patch in patches/${dir}_*.patch; do
227 test -r $patch || continue
Stefan Reinauerd7649122015-06-09 11:44:25 -0700228 printf " o $(basename $patch)\n"
Stefan Reinauer916b8452015-06-09 11:54:49 -0700229 $PATCH -s -N -p0 < $(echo $patch) || {
Stefan Reinauer88935482015-06-05 09:51:10 -0700230 printf "\n${RED}Failed $patch.${NC}\n"
Stefan Reinauer916b8452015-06-09 11:54:49 -0700231 exit 1
232 }
Stefan Reinauer88935482015-06-05 09:51:10 -0700233 done
234 touch ${dir}/.unpack_success
235 )
236}
237
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700238fn_exists()
239{
240 type $1 2>/dev/null | grep -q 'is a function'
Patrick Georgi74c06422015-03-25 18:40:13 +0100241}
242
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700243build() {
244 package=$1
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700245
246 fn_exists build_$package || return
247
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700248 version="$(eval echo \$$package"_VERSION")"
249 BUILDDIR=build-${TARGETARCH}-$package
250
251 mkdir -p ${BUILDDIR}
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700252
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700253 [[ "$PACKAGES" == *$package* ]] && \
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700254 if [ -f ${BUILDDIR}/.success ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700255 printf "Skipping $package as it is already built\n"
256 else
257 printf "Building $package $version ... "
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700258 DIR=$PWD
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700259 cd ${BUILDDIR}
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700260 rm -f .failed
261 build_${package} > build.log 2>&1
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700262 cd $DIR/${BUILDDIR}
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700263 if [ ! -f .failed ]; then touch .success; fi
264 cd ..
265
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700266 if [ -r "${BUILDDIR}/.failed" ]; then
267 printf "${RED}failed${NC}. Check ${BUILDDIR}/build.log.\n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700268 exit 1
269 fi
270 printf "${green}ok${NC}\n"
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700271 fi
272}
273
Stefan Reinauer074d9132009-09-26 16:43:17 +0000274cleanup()
275{
276 printf "Cleaning up temporary files... "
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700277 for package in $PACKAGES; do
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700278 rm -rf build-${TARGETARCH}-$package $(eval echo \$$package"_DIR")
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700279 done
Stefan Reinauer074d9132009-09-26 16:43:17 +0000280 printf "${green}ok${NC}\n"
281}
282
283myhelp()
284{
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700285 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-C] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000286 printf " $0 [-V|--version]\n"
287 printf " $0 [-h|--help]\n\n"
288
289 printf "Options:\n"
290 printf " [-V|--version] print version number and exit\n"
291 printf " [-h|--help] print this help and exit\n"
292 printf " [-c|--clean] remove temporary files before build\n"
293 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100294 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000295 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700296 printf " [-C|--clang] build CLANG toolchain"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000297 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700298 printf " (defaults to $TARGETARCH) *)\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000299 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
300 printf " (defaults to $TARGETDIR)\n\n"
301 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100302 printf " (for RPM builds, default unset)\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700303 printf " [-G|--gdb] build GNU debugger *)\n"
304 printf " [-S|--scripting] build scripting support for GDB *)\n\n"
305 printf " *) option only available when building GCC toolchain (not with CLANG)\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000306}
307
308myversion()
309{
310 # version tag is always printed, so just print the license here
311
312 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000313Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600314Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000315
316This program is free software; you can redistribute it and/or modify
317it under the terms of the GNU General Public License as published by
318the Free Software Foundation; version 2 of the License.
319
320This program is distributed in the hope that it will be useful,
321but WITHOUT ANY WARRANTY; without even the implied warranty of
322MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
323GNU General Public License for more details.
324
325EOF
326}
327
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700328build_GMP() {
329 CC="$CC" CFLAGS="-Os" ../${GMP_DIR}/configure --disable-shared --enable-fat --prefix=$TARGETDIR $OPTIONS \
330 || touch .failed
331 $MAKE $JOBS || touch .failed
332 $MAKE install DESTDIR=$DESTDIR || touch .failed
333
334 normalize_dirs
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700335
336 # Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
337 # as GCC 4.6.x fails if it's there.
338 export HOSTCFLAGS=$(grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
339 sed s,-pedantic,,)
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700340}
341
342build_MPFR() {
343 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
344 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
345 --infodir=$TARGETDIR/info \
346 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
347 touch .failed
348 $MAKE $JOBS || touch .failed
349 $MAKE install DESTDIR=$DESTDIR || touch .failed
350
351 normalize_dirs
352
353 # work around build problem of libgmp.la
354 if [ "$DESTDIR" != "" ]; then
355 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
356 fi
357}
358
359build_MPC() {
360 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
361 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
362 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
363 touch .failed
364 $MAKE $JOBS || touch .failed
365 $MAKE install DESTDIR=$DESTDIR || touch .failed
366
367 normalize_dirs
368}
369
370build_LIBELF() {
371 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
372 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
373 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
374 $MAKE $JOBS || touch .failed
375 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
376
377 normalize_dirs
378}
379
380build_BINUTILS() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700381 # Now build binutils
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700382 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
383 --target=${TARGETARCH} --disable-werror --disable-nls \
384 $USE_GOLD CFLAGS="$HOSTCFLAGS" || touch .failed
385 $MAKE $JOBS || touch .failed
386 $MAKE install DESTDIR=$DESTDIR || touch .failed
387}
388
389
390build_GCC() {
Stefan Reinauerd0f83722015-06-09 11:52:28 -0700391 # GCC does not honor HOSTCFLAGS at all. CFLAGS are used for
392 # both target and host object files.
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700393 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
394 # but it does not seem to work properly. At least the host library
395 # libiberty is not compiled with CFLAGS_FOR_BUILD.
396 CC="$CC" CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" \
397 CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
398 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
399 --target=${TARGETARCH} --disable-werror --disable-shared \
400 --disable-libssp --disable-bootstrap --disable-nls \
401 --disable-libquadmath --without-headers \
402 $GCC_OPTIONS --enable-languages="c" $USE_GOLD \
403 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
404 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
405 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
406 || touch .failed
407 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
408 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
409
Stefan Reinauerd7649122015-06-09 11:44:25 -0700410 if [ "$(echo $TARGETARCH | grep -c -- -mingw32)" -eq 0 ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700411 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
412 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
413 fi
414}
415
416build_EXPAT() {
417 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
418 --prefix=$TARGETDIR --target=${TARGETARCH} || touch .failed
419 $MAKE || touch .failed
420 $MAKE install DESTDIR=$DESTDIR || touch .failed
421
422 normalize_dirs
423}
424
425build_PYTHON() {
426 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
427 --target=${TARGETARCH} || touch .failed
428 $MAKE $JOBS || touch .failed
429 $MAKE install DESTDIR=$DESTDIR || touch .failed
430
431 normalize_dirs
432}
433
434build_GDB() {
435 export PYTHONHOME=$DESTDIR$TARGETDIR
436 if [ $(uname) != "FreeBSD" -a $(uname) != "NetBSD" ]; then
437 LIBDL="-ldl"
438 fi
439 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
440 -lpthread $LIBDL -lutil" \
441 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer7b40e422015-06-09 11:56:32 -0700442 ../${GDB_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700443 --target=${TARGETARCH} --disable-werror --disable-nls
444 $MAKE $JOBS || touch .failed
445 $MAKE install DESTDIR=$DESTDIR || touch .failed
446}
447
448build_IASL() {
449 RDIR=$PWD
450 cd ../$IASL_DIR/generate/unix
451 CFLAGS="$HOSTCFLAGS"
452 HOST="_LINUX"
453 test $UNAME = "Darwin" && HOST="_APPLE"
454 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
455 test $UNAME = "Cygwin" && HOST="_CYGWIN"
456 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2" CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch $RDIR/.failed
457 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch $RDIR/.failed
458 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch $RDIR/.failed
459}
460
461build_LLVM() {
462 cd ..
463 ln -sf $PWD/$CFE_DIR $LLVM_DIR/tools/clang
464 ln -sf $PWD/$CTE_DIR $LLVM_DIR/tools/clang/tools/extra
465 ln -sf $PWD/$CRT_DIR $LLVM_DIR/projects/compiler-rt
466 cd -
467
468 $CMAKE -G "Unix Makefiles" -DCMAKE_INSTALL_PREFIX=$DESTDIR$TARGETDIR \
469 -DCMAKE_BUILD_TYPE=Release ../$LLVM_DIR || touch .failed
470 $MAKE $JOBS || touch .failed
471 $MAKE install || touch .failed
472
473 cp -a ../$CFE_DIR/tools/scan-build/* $DESTDIR$TARGETDIR/bin
474 cp -a ../$CFE_DIR/tools/scan-view/* $DESTDIR$TARGETDIR/bin
475}
476
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700477printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000478
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000479# Look if we have getopt. If not, build it.
480export PATH=$PATH:.
481getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
482
Stefan Reinauer074d9132009-09-26 16:43:17 +0000483# parse parameters.. try to find out whether we're running GNU getopt
Stefan Reinauerd7649122015-06-09 11:44:25 -0700484getoptbrand="$(getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,')"
Peter Stuge09377b72011-08-21 06:24:55 +0200485if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000486 # Detected GNU getopt that supports long options.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700487 args=$(getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb,ccache,clang Vhcd:p:j:D:tGyC -- "$@")
Stefan Reinauer074d9132009-09-26 16:43:17 +0000488 eval set "$args"
489else
490 # Detected non-GNU getopt
Stefan Reinauerd7649122015-06-09 11:44:25 -0700491 args=$(getopt Vhcd:p:j:D:tGyC $*)
Stefan Reinauer074d9132009-09-26 16:43:17 +0000492 set -- $args
493fi
494
495if [ $? != 0 ]; then
496 myhelp
497 exit 1
498fi
499
500while true ; do
501 case "$1" in
502 -V|--version) shift; myversion; exit 0;;
503 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100504 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000505 -t|--savetemps) shift; SAVETEMPS=1;;
506 -d|--directory) shift; TARGETDIR="$1"; shift;;
507 -p|--platform) shift; TARGETARCH="$1"; shift;;
508 -D|--destdir) shift; DESTDIR="$1"; shift;;
Patrick Georgi73166c72010-04-14 20:42:42 +0000509 -j|--jobs) shift; JOBS="-j $1"; shift;;
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700510 -C|--clang) shift; BUILDCLANG=1;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100511 -G|--gdb) shift; SKIPGDB=0;;
512 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100513 -y|--ccache) shift; USECCACHE=1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200514 --) shift; break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000515 -*) printf "Invalid option\n\n"; myhelp; exit 1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200516 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000517 esac
518done
519
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700520case "$TARGETARCH" in
Stefan Reinauer24f9cb92015-03-13 22:50:22 +0100521 x86_64-elf) ;;
522 x86_64*) TARGETARCH=x86_64-elf;;
David Hubbard5b0420a2013-05-28 16:33:15 -0600523 i386-elf) ;;
524 i386-mingw32) ;;
Patrick Georgi9b7efa52015-03-08 09:20:36 +0100525 mipsel-elf) ;;
Patrick Georgif0bbc952015-03-07 10:57:25 +0100526 riscv-elf) ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700527 i386*) TARGETARCH=i386-elf;;
Patrick Georgic8883262013-09-19 10:57:58 +0200528 arm*) TARGETARCH=armv7-a-eabi;;
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700529 aarch64*) TARGETARCH=aarch64-elf;;
530 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700531esac
532
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700533# Figure out which packages to build
Stefan Reinauer699ac272015-06-05 12:43:28 -0700534
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700535if [ "$BUILDCLANG" -eq 0 ]; then
536 echo "Target architecture is now $TARGETARCH"
537 NAME="${TARGETARCH} cross"
538 PACKAGES="GMP MPFR MPC LIBELF BINUTILS GCC IASL"
539else
540 NAME=clang
541 PACKAGES="LLVM CFE CRT CTE"
Patrick Georgi44af57a2013-12-19 22:06:22 +0100542fi
543
Peter Stugeceacd772011-06-09 04:54:16 +0200544if [ $SKIPGDB -eq 1 ]; then
545 printf "Will skip GDB ... ${green}ok${NC}\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100546 if [ $SKIPPYTHON -eq 0 ]; then
547 printf "Python scripting needs GDB ... disabling ... ${green}ok${NC}\n"
548 SKIPPYTHON=1
549 fi
Stefan Reinauer699ac272015-06-05 12:43:28 -0700550else
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700551 if [ $SKIPPYTHON -eq 0 ]; then
552 PACKAGES="$PACKAGES EXPAT PYTHON"
553 fi
Stefan Reinauer699ac272015-06-05 12:43:28 -0700554 PACKAGES="$PACKAGES GDB"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100555fi
Peter Stugeceacd772011-06-09 04:54:16 +0200556
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700557# This initial cleanup is useful when updating the toolchain script.
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000558
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700559if [ "$clean" = "1" ]; then
560 cleanup
561fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000562
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700563# Set up host compiler and flags needed for various OSes
Stefan Reinauer074d9132009-09-26 16:43:17 +0000564
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700565if [[ "$PACKAGES" == *GCC* ]]; then
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700566CC=cc
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700567if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000568 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
569
570 # generally the OS X compiler can create x64 binaries.
571 # Per default it generated i386 binaries in 10.5 and x64
572 # binaries in 10.6 (even if the kernel is 32bit)
573 # For some weird reason, 10.5 autodetects an ABI=64 though
574 # so we're setting the ABI explicitly here.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700575 if [ $(sysctl -n hw.optional.x86_64 2>/dev/null) -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000576 OPTIONS="ABI=64"
577 else
578 OPTIONS="ABI=32"
579 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700580
Stefan Reinauer4266b922012-12-05 16:18:32 -0800581 # In Xcode 4.5.2 the default compiler is clang.
582 # However, this compiler fails to compile gcc 4.7.x. As a
583 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700584 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800585 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700586 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000587fi
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700588fi # GCC
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000589
Patrick Georgic1a75b12011-11-04 21:37:14 +0100590if [ "$USECCACHE" = 1 ]; then
591 CC="ccache $CC"
592fi
593
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700594# coreboot does not like the GOLD linker
595# USE_GOLD="--enable-gold"
596USE_GOLD=""
597GCC_OPTIONS="--enable-lto"
598
599# Prepare target directory for building GCC
600# (dependencies must be in the PATH)
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100601mkdir -p $DESTDIR$TARGETDIR/bin
602export PATH=$DESTDIR$TARGETDIR/bin:$PATH
603
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700604# Download, unpack, patch and build all packages
605
606printf "Downloading tar balls ... \n"
607mkdir -p tarballs
608for P in $PACKAGES; do
609 download $P
610done
611printf "Downloaded tar balls ... ${green}ok${NC}\n"
612
613printf "Unpacking and patching ... \n"
614for P in $PACKAGES; do
615 unpack_and_patch $P || exit 1
616done
617printf "Unpacked and patched ... ${green}ok${NC}\n"
618
619printf "Building packages ... \n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700620for package in $PACKAGES; do
621 build $package
622done
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700623printf "Packages built ... ${green}ok${NC}\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700624
Stefan Reinauer699ac272015-06-05 12:43:28 -0700625# Adding git information of current tree to target directory
626# for reproducibility
Stefan Reinauerd7649122015-06-09 11:44:25 -0700627PROGNAME=$(basename "$0")
Patrick Georgi5602f2c2015-03-28 15:48:47 +0100628rm -f "$DESTDIR$TARGETDIR/$PROGNAME".commit.*
Stefan Reinauerd7649122015-06-09 11:44:25 -0700629cp "$PROGNAME" $DESTDIR$TARGETDIR/"$PROGNAME.commit.$(git describe)"
Zheng Bao30b895f2013-02-06 18:04:40 +0800630
Stefan Reinauer074d9132009-09-26 16:43:17 +0000631if [ $SAVETEMPS -eq 0 ]; then
Stefan Reinauer699ac272015-06-05 12:43:28 -0700632 cleanup
Stefan Reinauer074d9132009-09-26 16:43:17 +0000633else
634 printf "Leaving temporary files around... ${green}ok${NC}\n"
635fi
636
Stefan Reinauer699ac272015-06-05 12:43:28 -0700637printf "\n${green}You can now run your $NAME toolchain from $TARGETDIR.${NC}\n"